package de.fhdw.wtf.common.stream.test;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import de.fhdw.wtf.common.stream.FilteredTokenStream;
import de.fhdw.wtf.common.token.CommentTextToken;
import de.fhdw.wtf.common.token.IdentifierToken;
import de.fhdw.wtf.common.token.Position;
import de.fhdw.wtf.common.token.Token;
import de.fhdw.wtf.common.token.WhitespaceToken;

public class FilteredTokenStreamTest {
	
	@Test
	public void test() {
		
		final Token t1 = WhitespaceToken.create("t1", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t2 = IdentifierToken.create("t2", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t3 = IdentifierToken.create("t3", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t4 = WhitespaceToken.create("t4", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t5 = CommentTextToken.create("t5", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t6 = WhitespaceToken.create("t6", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t7 = IdentifierToken.create("t7", Position.create("", 0 + 1, 0 + 1, 0));
		final Token t8 = WhitespaceToken.create("t8", Position.create("", 0 + 1, 0 + 1, 0));
		
		final FilteredTokenStream stream = FilteredTokenStream.create();
		stream.add(t1);
		stream.add(t2);
		stream.add(t3);
		stream.add(t4);
		stream.add(t5);
		stream.add(t6);
		stream.add(t7);
		stream.add(t8);
		
		assertEquals(true, stream.hasNext());
		assertEquals(t2, stream.peek());
		assertEquals(t2, stream.next());
		assertEquals(true, stream.hasNext());
		assertEquals(t3, stream.peek());
		assertEquals(t3, stream.next());
		assertEquals(true, stream.hasNext());
		assertEquals(t7, stream.peek());
		assertEquals(t7, stream.next());
		assertEquals(false, stream.hasNext());
	}
	
}
